// Datoteka simu1.cpp
#include "simu1.h"
#include <iostream>

// Ukljucujemo prostore imena simu1 i std
using namespace simu1;
using namespace std;

// Redni broj dogadjaja DolazakKlijenta
const int DOLAZAK_KLIJENTA = 1;
// Redni broj dogadjaja OdlazakKlijenta
const int ODLAZAK_KLIJENTA = 2;

// Potpis funkcije bezuslovnog dogadjaja DolazakKlijenta
void dolazak_klijenta(entitet *e);
// Potpis funkcije bezuslovnog dogadjaja OdlazakKlijenta
void odlazak_klijenta(entitet *e);

// Izvrsavanje dogadjaja
void simulacija::izvrsavanje_dogadjaja(int dog, entitet* e) {
  switch(dog) {
    case DOLAZAK_KLIJENTA:
      dolazak_klijenta(e);
      break;
    case ODLAZAK_KLIJENTA:
      odlazak_klijenta(e);
      break;
  }
}

// Vremenski trenuci dolaska entiteta (Tabela 1)
double vreme_dolaska[] = { 0.0, 1.0, 1.0, 1.0, 2.0, 4.0,
                           4.0, 4.0, 4.0, 5.0, 5.0, 6.0, 8.0 };
// Vreme opsluge entiteta (Tabela 1)
double vreme_opsluge[] = { 4.0, 3.0, 4.0, 3.0, 1.0, 4.0, 
                           2.0, 1.0, 2.0, 1.0, 1.0, 1.0, 3.0 };

// Objekat reda cekanja
fifo_red red;
// Salteri
resurs salteri(4);
// Objekat simulacije
simulacija simu;

void dolazak_klijenta(entitet *e) {
  entitet *fe, *ne;
  // Stampa u izvestaj
  cout << simu.vrati_vreme_simulacije() << ": Klijent " << e->vrati_id() << " dolazi u postu." << endl;
  // Postavi klijenta u red cekanja
  red.ured(e);
  // Ukoliko je salter raspoloziv
  if(salteri.raspoloziv()) {
    // Izvadi prvog klijenta iz reda
    fe = red.izred();
    // Zauzmi jedno mesto u salteru
    salteri.zauzmi();
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(fe,ODLAZAK_KLIJENTA,simu.vrati_vreme_simulacije()+vreme_opsluge[fe->vrati_id()-1]);
  }
  // Stampa u izvestaj
  cout << simu.vrati_vreme_simulacije() << ": Klijenti u redu: "; red.stampa(); cout << "."  << endl;
  cout << simu.vrati_vreme_simulacije() << ": Klijenti u sistemu: "; simu.stampaj_listu(); cout << "."  << endl;
  // Stvaramo narednog klijenta
  ne = simu.napravi_entitet();
  if(ne->vrati_id()<=13)
    // Postavljamo vreme narednog dolaska
    simu.rasporedi(ne,DOLAZAK_KLIJENTA,vreme_dolaska[ne->vrati_id()-1]);
  else
    simu.unisti_entitet(ne,0);
}

void odlazak_klijenta(entitet *e) {
  entitet *fe;
  // Vrati salter;
  salteri.oslobodi();
  // Stampa u izvestaj
  cout << simu.vrati_vreme_simulacije() << ": Klijent " << e->vrati_id() << " odlazi iz poste." << endl;
  // Klijent odlazi iz poste - unistavamo tekuceg klijenta
  simu.unisti_entitet(e,1);
  // Ukoliko red nije prazan
  if(red.velicina()>0) {
    // Izvadi prvog klijenta iz reda
    fe = red.izred();
    // Zauzmi jedno mesto u salteru
    salteri.zauzmi();
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(fe,ODLAZAK_KLIJENTA,simu.vrati_vreme_simulacije()+vreme_opsluge[fe->vrati_id()-1]);
  }
  // Stampa u izvestaj
  cout << simu.vrati_vreme_simulacije() << ": Klijenti u redu: "; red.stampa(); cout << "."  << endl;
  cout << simu.vrati_vreme_simulacije() << ": Klijenti u sistemu: "; simu.stampaj_listu(); cout << "."  << endl;
}

int main() {
  // Stvaramo prvog klijenta
  entitet *e = simu.napravi_entitet();
  // Postavljamo vreme dolaska prvog klijenta
  simu.rasporedi(e,DOLAZAK_KLIJENTA,vreme_dolaska[e->vrati_id()-1]);
  // Izvrsavamo simulaciju
  simu.izvrsi(13);
}