// Datototeka simu2.cpp
#include "simu2.h"
#include <iostream>

// Ukljucujemo prostore imena simu2 i std
using namespace simu2;
using namespace std;

// Redni broj dogadjaja DolazakKlijenta
const int DOLAZAK_KLIJENTA = 0;
// Redni broj dogadjaja OdlazakKlijenta
const int ODLAZAK_KLIJENTA = 1;
// Redni broj dogadjaja KrajSimulacije
const int KRAJ_SIMULACIJE  = 2;

// Potpis funkcije bezuslovnog dogadjaja DolazakKlijenta
void dolazak_klijenta(entitet *e);
// Potpis funkcije bezuslovnog dogadjaja OdlazakKlijenta
void odlazak_klijenta(entitet *e);
// Potpis funkcije bezuslovnog dogadjaja KrajSimulacije
void kraj_simulacije(entitet *e);

// Izvrsavanje dogadjaja
void simulacija::izvrsavanje_dogadjaja(int dog, entitet* e) {
  switch(dog) {
    case DOLAZAK_KLIJENTA:
      dolazak_klijenata(e);
      break;
    case ODLAZAK_KLIJENTA:
      odlazak_klijenata(e);
      break;
    case KRAJ_SIMULACIJE:
      kraj_simulacije(e);
  }
}

// Objekat reda cekanja
fifo_red red;
// Salteri
resurs salteri(4);
// Objekat simulacije
simulacija simu;
// Raspodele
raspodela rn1(11615), rn2(36517);
// Srednje vreme dolaska entiteta
const double SRVRDOL = 100;
// Srednjevreme opsluge entiteta
const double SRVROPS = 200;

// Dogadjaj dolazak klijenta
void dolazak_klijenta(entitet *e) {
  entitet *fe, *ne;
  cout << "ured" << "," << e->vrati_id() << "," << simu.vrati_vreme_simulacije() << endl;
  // Postavi klijenta u red cekanja
  red.ured(e);
  // Ukoliko je salter raspoloziv
  if(salteri.raspoloziv()) {
    // Izvadi prvog klijenta iz reda
    fe = red.izred();
    cout << "izred" << "," << fe->vrati_id() << "," << simu.vrati_vreme_simulacije() << endl;
    // Zauzmi jedno mesto u salteru
    salteri.zauzmi();
    cout << "usal" << "," << fe->vrati_id() << "," << simu.vrati_vreme_simulacije() << endl;
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(fe,ODLAZAK_KLIJENTA,simu.vrati_vreme_simulacije()+rn2.expo(SRVROPS));
  }
  // Stvaramo narednog klijenta
  ne = simu.napravi_entitet();
  // Postavljamo vreme narednog dolaska
  simu.rasporedi(ne,DOLAZAK_KLIJENTA,simu.vrati_vreme_simulacije()+rn1.expo(SRVRDOL));
}
// Dogadjaj odlazak klijenta
void odlazak_klijenta(entitet *e) {
  entitet *fe;
  // Vrati salter;
  salteri.oslobodi();
  cout << "izsal" << "," << e->vrati_id() << "," << simu.vrati_vreme_simulacije() << endl;
  // Klijent odlazi iz poste - unistavamo tekuceg klijenta
  simu.unisti_entitet(e,0);
  // Ukoliko red nije prazan
  if(red.velicina()>0) {
    // Izvadi prvog klijenta iz reda
    fe = red.izred();
    cout << "izred" << "," << fe->vrati_id() << "," << simu.vrati_vreme_simulacije() << endl;
    // Zauzmi jedno mesto u salteru
    salteri.zauzmi();
    cout << "usal" << "," << fe->vrati_id() << "," << simu.vrati_vreme_simulacije() << endl;
    // Rasporedi klijenta za kraj opsluge 
    simu.rasporedi(fe,ODLAZAK_KLIJENTA,simu.vrati_vreme_simulacije()+rn2.expo(SRVROPS));
  }
}
// Dogadjaj kraj simulacije
void kraj_simulacije(entitet* e) {
  simu.unisti_entitet(e,1);
  // Stampamo vreme simulacije
  cout << "vsim" << "," << -1 << "," << simu.vrati_vreme_simulacije() << endl;
}
int main() {
  // Stvaramo prvog klijenta
  entitet *e1 = simu.napravi_entitet();
  // Postavljamo vreme dolaska prvog klijenta
  simu.rasporedi(e1,DOLAZAK_KLIJENTA,rn1.expo(SRVRDOL));
  // Stvaramo entitet za kraj simulacije
  entitet *e2 = simu.napravi_entitet();
  // Postavljamo vreme zavrsetka simulacije
  simu.rasporedi(e2,KRAJ_SIMULACIJE,43200);
  // Izvrsavamo simulaciju
  simu.izvrsi(1);
}
