#include <iostream>
#include <cmath>

using namespace std;

#define OPEN_SVG  cout << "<svg xmlns='http://www.w3.org/2000/svg' version='1.1'>" << endl
#define CLOSE_SVG cout << "</svg>" << endl

// Klasa tacka u ravni
class tacka {
public:
  // Difoltni konstruktor
  tacka() { x=0; y=0; }
  // Konstruktor
  tacka(int xx,int yy) {
    x = xx;
    y = yy; 
  }
public:
  // Svojstva
  void postavi_x(const int xx) { x = xx; }
  void postavi_y(const int yy) { y = yy; }
  
  int vrati_x() const { return x; }
  int vrati_y() const { return y; }  
private:
  int x, y;
};

// Klasa linija u ravni
class linija {
public:
  // Difoltni konstruktor
  linija() {}
  // Konstruktor
  linija(tacka& tt1,tacka& tt2); 
public:
  // Metode
  // Crtanje
  void crtaj();
  // Vraca duzinu linije
  double duzina();
public:
  // Svojstva
  void postavi_t1(const tacka& tt1); 
  void postavi_t2(const tacka& tt1);
private:
  tacka t1, t2;
};

// Konstruktor
linija::linija(tacka& tt1, tacka& tt2) {
  t1 = tt1;
  t2 = tt2;
}
// Crtanje
void linija::crtaj() {
  cout << "<text x='" << t1.vrati_x()+(t2.vrati_x()-t1.vrati_x())/2 << "' y='" << t1.vrati_y()+(t2.vrati_y()-t1.vrati_y())/2 << "' fill='orange'>" << duzina() << "</text>";
  cout << "<line x1='" << t1.vrati_x() << "' y1='" << t1.vrati_y() << "' x2='" << t2.vrati_x() << "' y2='" << t2.vrati_y() << "' stroke='blue'/>" << endl;
}
// Duzina linije
double linija::duzina() {
  return sqrt(pow(t2.vrati_x()-t1.vrati_x(),2)+pow(t2.vrati_y()-t1.vrati_y(),2));
}
void linija::postavi_t1(const tacka& tt1) {
  t1 = tt1;
}
void linija::postavi_t2(const tacka& tt2) {
  t2 = tt2;
}

int main() {
  // Otvaramo SVG datoteku
  OPEN_SVG;
  
  tacka t1, t2;
  t1.postavi_x(50); t1.postavi_y(50);
  t2.postavi_x(500); t2.postavi_y(50);
  
  // Pozivamo konstruktor
  linija lin1(t1,t2);
  // Iscrtavamo liniju
  lin1.crtaj();

  tacka t3(500,50), t4(500,450);
  
  // Pozivamo difoltni konstruktor
  linija *lin2 = new linija;
  // Postavljamo tacke
  lin2->postavi_t1(t3);
  lin2->postavi_t2(t4);
  // Iscrtavamo liniju
  lin2->crtaj();

  // Zatvaramo SVG datoteku
  CLOSE_SVG;

  // Oslobadamo memoriju
  delete lin2;
  
  return 0;
};
